# -*- coding: utf-8 -*-

# abcd   <----- ein Kommentar
"""
Auch ein Kommentar
"""



# Vorgeplänkel: Import von Modulen ------------------------------------
# Für Physiker wichtig: numpy, scipy, matplotlib (, mayavi)
import os
from matplotlib.pylab import *
import matplotlib.pylab
import matplotlib
from pylab import *
from numpy import *
matplotlib.use('Qt4Agg')
# from mayavi import mlab as ml       # 3D Plots. Ist nicht immer installiert -> Nachinstallieren


# Python *hat* eine, aber eine sehr *einfache* Syntax


# Rechnen ---------------------------------------------
1*2
2/2
1/2
1./2
1j*2j
sin(1.2)**2
cos(1.2)**2

# Konstanten ---------------------------------------------
1
1.2
1+2.3j

# Variablen-Zuweisung ---------------------------------------------
x = 1
y = 2.
a,b = x,y

# weitere Variablen-Zuweisung --------------------------------------
t = (1,2,3)                           # Tupel
u = 'Abrakadabra'                     # Strings
v = [1,1.2,2,-2,'Huhu']               # Listen
w = {'Meier':1,'Mueller':2,12:'Rabe'} # Dictionary
m = array([[1,2],                     # 2x2 array
           [3,4]])

# Hilfe ist immer in der Nähe: 1) WWW, 2) built in
m?
type(m)
help(array)
dir(m)
# Python ist in Inglisch dokumentiert 

# 'vorgekochte' Datentypen ---------------------------------------------
print type(1)
print type(1.2)
print type(1+2.3j)
print type(t)
print type(u)
print type(v)
print type(w)
print type(m)       # erst durch numpy

# Indizierung ---------------------------------------------------
u[9]

v[0]
v[-1]
v[2]
v[2:4]

w['Meier']
w[12]

m[1,1]
m[1,:]

# 'ungewöhnliches' Rechnen --------------------------------------
t+t
v+v
w+w  # error
m*m
m[0,:]+m[1,:]
m[0,:] = m[0,:]+m[1,:]
dot(m,m)
m[m<=3]+=1




# Funktion -------------------------------------------------
def f(x):                    # x = Variable
    return cos(x)-x**2       # f(x) zurück
    
f(0)
f(1)    
    
f(array([1,2,3,4]))          # manchmal elementwise operations 

a = 3.7                      # der 'Namensraum' = scope
def f(x):
    return cos(x)-a**2
def f(x):
    a=3.7
    return cos(x)-a**2    
def f(x,y):                  # nicht nur ein Argument
    return cos(x)-y**2
def f(x,y):                  # nicht nur ein return value
    return cos(x),y**2
def f(x,y=1):                # 'default' variables
    return cos(x),y**2
def f(x,*args):              # beliebige Argumente
    print x
    for i,y in enumerate(args):
        print i,y
        
# Achtung: **kwargs Argumente fehlen
        
# Andere goodies: closures(!), decorators(!), generators(!!), coroutines(!!!)





# for 'Schleifen' ---------Beachte ':' und Einschub-----------------
range(10)

for i in range(10):   # <- Interation
    print i
    
for i in w:           # <- Interation über alles 'Iterierbare'
    print i,w[i]
    print str(i)+','+str(w[i])

for i in u:           # <- Interation über alles 'Iterierbare'
    print i
    
# while 'Schleifen' ---------------------------------------------
i = 5
while i<10:
    print i
    i += 1        # i = i+1
    
# Entscheidungen -------------------------------------------------
x = 3.1
if x < 0:
    print 'Negativ'
elif x == 0:
    print 'Null'
else:
    print 'Positiv'




# Optimierung durch 'built in functionality' ------------------------    
# In Python gibt es für viele Situationen mit 'Bedarf für Schleifen' einen
# Ersatz der schneller sein kann (Umgehung des Interpreters)
N = 300
cut = 0.5
m = random.random((N,N))

def kc1():
    '''Finde Elemente in m kleiner 'cut''' 
    s = 0
    for i in range(N):
        for j in range(N):
            if m[i,j] < cut:
                s+=1
    return s

def kc2():
    '''Finde Elemente in m kleiner 'cut''' 
    return sum(array(m<.5,dtype=int).ravel())   

# kc1 und kc2 machen das Gleiche ... nur sehr unterschiedlich schnell 

%timeit -n 100 kc1()    
%timeit -n 100 kc2()   

# Achtung: für die meisten Probleme die man betrachtet sind solche Frage unwichtig!!!!
# 'beware of premature optimization'    


# List comprehension: nette Methode Listen zu erzeugen. Lässt sich leicht verallgem.
A = [x**2 for x in range(10)]
B = [x for x in A if x % 2 == 0]


# Anonyme Funktionen + funktionale Programmierung --------------------
type(lambda x: x**2) 
(lambda x: x**2)(5)
(lambda x: x**2)(7)
y = [1, 2, 3, 4]
map(lambda x: x**2,y)  # wende anonyme Funktion auf jedes Element von y an
# geht mit NumPy meist einfacher
y = array([1,2,3,4])
y**2

    
# Ein Bildchen = Plot ------------------------------------------------    
x = linspace(-3,3,201)
print type(x),x.shape,f(x).shape

def f(x):                    # x = Variable
    return cos(x)-x**2       # f(x) zurück

plot(x,f(x),color='red')
xlabel('x')
ylabel('y')
savefig('peanuts.pdf')     # für die Nachwelt

# Zwei Plots  -----------------------------------------------------------
fig = figure()
ax = fig.add_subplot(121)
plot(x,f(x),color='red')
xlabel('x')
ylabel('y')
ax = fig.add_subplot(122)
plot(x,f(x),color='red')
xlabel('x')
ylabel('y')
savefig('peanuts.pdf')


## --------------------------------------------------------------------------
## 3D Bildchen ---- Unterstützung nicht so toll. Es gibt frei Super-Pro-Libs:
## 1) ParaView (Sandia Lab)
## 2) VisIt    (Lawrence Livermore)
## Etwas harmloseres Tool: MayaViII 
## Dispersionsrelationen von Graphen
#def egr(x,y,s):
#    return sign(s)*sqrt(3+2*cos(x)+4*cos(x/2)*cos(sqrt(3)*y/2))
#
#N=300
#x,y = mgrid[-2*pi:2*pi:N*1j,-2*pi:2*pi:N*1j]
#zp = egr(x,y,1)
#zm = egr(x,y,-1)
#ws=2
#ml.figure()
#ml.surf(x,y,zp,warp_scale=ws,colormap='jet')
#ml.surf(x,y,zm,warp_scale=ws,colormap='jet')
#ml.savefig('Graphene.png',size=(500,500))



# Ein Progrämmchen ----------------------------------------------------
def df(x):
    return -sin(x)-2*x

def null(f,df,x0,eps):
    """
    null(f,df,x0,eps) Newton Verfahren für die Gl. f(x)=0
    Input:   f, function, Funtion einer Veränderlichen
            df, function, df(x)/dx
            x0, float, Startwert
            eps,float, Relative Genauigkeit der Lösung
    Output: x1,f(x1), float tuple, Lösung, Funktionswert 
    """
    x1 = x0 - f(x0)/df(x0)
    while abs((x1-x0)/(x1+x0)) > eps:
        print x1    # Schau drauf
        x0 = x1
        x1 = x0 - f(x0)/df(x0)
    return x1,f(x1)

# Testlauf        
null(f,df,1.,1e-6)
null(f,df,.1,1e-6)
null(f,df,.01,1e-6)
null(f,df,-.01,1e-6)

# Achtung: f und df sind nicht 'irgendwie' festgelegt +++++++++++++++++
def g(x):
    return sin(cos(x**2))
def dg(x):
    return -2*x*sin(x**2)*cos(cos(x**2))
plot(x,g(x),color='red')




# File Input/Output ---------------------------------------------------
os.chdir('/Irgendwohin')
import scipy.optimize as optimization  # paar Sachen nachladen

dat = transpose(loadtxt('dat.txt'))  # 3 Std. harte Praktikumsarbeit
plot(dat[0],dat[1],'-o')

def func(x, a, b, c):                # Geniale Theorie für die Daten
    return a + b*x + c*x*x

fit,cov = optimization.curve_fit(func,dat[0],dat[1]) # Least square fit

x = linspace(0,5,100)                # alles plotten
plot(x,func(x,fit[0],fit[1],fit[2]))
plot(dat[0],dat[1],'o')
savetxt('dat1.txt',transpose(array((x,f(x)))))

# jetzt noch ein bisschen mit Fehlerbalken
dat = transpose(loadtxt('dat2.txt'))  # 7.5 Std. harte Praktikumsarbeit
avg = mean(dat[1:4,:],0)
sig = std(dat[1:4,:],0)
errorbar(dat[0,:],avg,yerr=sig)
fit,cov = optimization.curve_fit(func,dat[0],dat[1]) # Least square fit
x = linspace(0,5,100)                # alles plotten
plot(x,func(x,fit[0],fit[1],fit[2]))
plot(dat[0],dat[1],'o')



# Tabellen, EXCEL und anderer Schwachsinn ?!?!?!?! ----------------------
import xlwt # für Schreiben 'write' gibt auch xlrd für Lesen 'read'
from tempfile import TemporaryFile
book = xlwt.Workbook()
sheet1 = book.add_sheet('sheet1')

x = linspace(0,2*pi,100)
for i in range(len(x)):
    sheet1.write(i,0,x[i])
    sheet1.write(i,1,sin(x[i]))

name = "this.xls"
book.save(name)
book.save(TemporaryFile())

import xlrd
wb = xlrd.open_workbook('this.xls')
sh1 = wb.sheet_by_name('sheet1')
x1 = transpose(array([sh1.col_values(0),sh1.col_values(1)]))

# Fazit: wer glaubt M$-Viren für Wissenschaft zu brauchen ist selbts schuld.

# Wenn man sein Zeit so richtig verquasen will -> http://www.reportlab.com/

# Lineare Gleichung lösen ---------------------------------------------
# Fehlt



# If time left =========================================================
# classes, polymorphism ---------------------------------------

# Im WWW findet man viele BSP für Klassen, z.B. Bankkonten, Patientenkarten,
# Tierstammbäume .... ich habe keinen blassen Schimmer was das mit Mathe und
# Physik zu tun hat.
# Wir bauen eine einfache Klasse für eine 'seltsame' Zahlensorte: Quaternionen -> siehe Wikipedia
class Quaternion(object):
    '''Quaternion class. Implements subset of quaternion algebra'''
    def __init__(self,t,x,y,z):
        '''Construct instance'''
        self.t,self.x,self.y,self.z = t,x,y,z
        
    def __repr__(self):
        '''Pretty print'''
        return "(%3.2f %3.2f %3.2f %3.2f)" % (self.t,self.x,self.y,self.z) 
            
    def __add__(self,a):
        '''Overload addition'''
        if isinstance(a,self.__class__):
            return Quaternion(self.t+a.t,self.x+a.x,self.y+a.y,self.z+a.z)
        else:
            raise TypeError("unsupported operand")

    def __sub__(self,a):
        '''Overload subtraction'''
        if isinstance(a,self.__class__):
            return Quaternion(self.t-a.t,self.x-a.x,self.y-a.y,self.z-a.z)
        else:
            raise TypeError("unsupported operand")
            
    def __mul__(self,a):
        '''Overload multiplication'''
        if isinstance(a,self.__class__):
            return Quaternion(
                self.t*a.t - (self.x*a.x+self.y*a.y+self.z*a.z),
                self.t*a.x + self.x*a.t + (self.y*a.z-self.z*a.y),
                self.t*a.y + self.y*a.t + (self.z*a.x-self.x*a.z),
                self.t*a.z + self.z*a.t + (self.x*a.y-self.y*a.x))
        else:
            raise TypeError("unsupported operand")

    def __div__(self,a):
        '''Overload division (by float)'''
        a = float(a)
        return Quaternion(self.t/a,self.x/a,self.y/a,self.z/a)

    def conj(self):
        '''Conjugation'''
        return Quaternion(self.t,-self.x,-self.y,-self.z)
                
    def n2(self):
        '''Norm'''
        return (self*self.conj()).t
        
    def __eq__(self,a):
        '''Equality - up to machine precision'''
        if isinstance(a,self.__class__):
            return (sqrt((self.t-a.t)**2+(self.x-a.x)**2+
                (self.y-a.y)**2+(self.z-a.z)**2) < 1e-15)
        else:
            raise TypeError("unsupported operand")

    def __hash__(self):
        '''Hash. Needed if used for dictionary keys'''
        return hash((self.t,self.x,self.y,self.z))

# Jetzt nutzen wir die Klasse:
# Tabelle der 24 Norm-1 Hurwitz Quaternionen. Beweise das Q24 eine endliche
# Gruppe ist = Ecken des regulärer 24-Zeller = Ikositetrachoron.
# Q24 = dictionary: key=Quaternion, val=index into multiplication table           
Q24 = {
# all elements of Q8
Quaternion( 1, 0, 0, 0):  0,
Quaternion(-1, 0, 0, 0):  1,
Quaternion( 0, 1, 0, 0):  2,
Quaternion( 0,-1, 0, 0):  3,
Quaternion( 0, 0, 1, 0):  4,
Quaternion( 0, 0,-1, 0):  5,
Quaternion( 0, 0, 0, 1):  6,
Quaternion( 0, 0, 0,-1):  7,
# all elements of Q16
# 0 minus signs =1
Quaternion( 1, 1, 1, 1)/2:8,
# 1 minus sign (4 1) = 4
Quaternion(-1, 1, 1, 1)/2:9,
Quaternion( 1,-1, 1, 1)/2:10,
Quaternion( 1, 1,-1, 1)/2:11,
Quaternion( 1, 1, 1,-1)/2:12,
# 2 minus signs (4 2) = 6
Quaternion(-1,-1, 1, 1)/2:13,
Quaternion(-1, 1,-1, 1)/2:14,
Quaternion(-1, 1, 1,-1)/2:15,
Quaternion( 1,-1,-1, 1)/2:16,
Quaternion( 1,-1, 1,-1)/2:17,
Quaternion( 1, 1,-1,-1)/2:18,
# 3 minus signs (4 3) = 4
Quaternion(-1,-1,-1, 1)/2:19,
Quaternion(-1, 1,-1,-1)/2:20,
Quaternion(-1,-1, 1,-1)/2:21,
Quaternion( 1,-1,-1,-1)/2:22,
# 4 minus signs = 1
Quaternion(-1,-1,-1,-1)/2:23
}

set_printoptions(edgeitems=1000,linewidth=200)  # Ansichtssache
GroupTable = -1*ones((24,24),dtype=int)         # bisher keine Gruppenelemente
for i,ii in Q24.iteritems():                    # Schleife: Spezialität über key UND val
    for j,jj in Q24.iteritems():                # Schleife: Spezialität über key UND val
        # Jetzt der Haupttrick. Mul beide Quats und benützte Resultat as key fürs
        # dictionary -> wenn in Q24 enthalten setzte das resultierende Element in die
        # Multiplikationstafel ein. Wenn nicht in Q24 enthalten, lass die -1 drin 
        try:
            GroupTable[ii,jj] = Q24[i*j]
        except KeyError:
            pass

# Test if any elements of GroupTable have remained '-1'   
set((GroupTable==-1).ravel())




# ============================================================================
# Wenn Zeit ist
# Plot für Kontroll-Freaks
# Fonts
fntsz = 20
axfntsz = 24
tdis = 8
linth = 2
axthick = 2

# Axenkreuz
fig = figure(figsize=(7,7))
ax = fig.add_subplot(111)
subplots_adjust(bottom=0.13,left=0.17)
for i in ax.spines.itervalues():
    i.set_linewidth(axthick)

# x Axen
ax.xaxis.set_major_locator(MultipleLocator(1))
ax.xaxis.set_minor_locator(MultipleLocator(.5))
for label in ax.xaxis.get_ticklabels():
    label.set_fontsize(fntsz)
for line in ax.xaxis.get_majorticklines():
    line.set_markersize(6)
    line.set_markeredgewidth(2)
for line in ax.xaxis.get_minorticklines():
    line.set_markersize(4)
    line.set_markeredgewidth(2)
for tick in ax.xaxis.get_major_ticks():
    tick.set_pad(tdis)
ax.xaxis.set_label_text('x',fontsize=axfntsz)
ax.xaxis.set_label_coords(0.5,-.1)

# y Axen
ax.yaxis.set_major_locator(MultipleLocator(1))
ax.yaxis.set_minor_locator(MultipleLocator(.5))
for label in ax.yaxis.get_ticklabels():
    label.set_fontsize(fntsz)
for line in ax.yaxis.get_majorticklines():
    line.set_markersize(6)
    line.set_markeredgewidth(2)
for line in ax.yaxis.get_minorticklines():
    line.set_markersize(4)
    line.set_markeredgewidth(2)
for tick in ax.yaxis.get_major_ticks():
    tick.set_pad(tdis)
ax.yaxis.set_label_text('f(x)',fontsize=axfntsz)
ax.yaxis.set_label_coords(-.13,0.5)

# .... puuh, endlich: die Funktion
ax.plot(x,f(x),linewidth=linth,color='red',label='I')

# Weihnachstgans
ax.set_axis_bgcolor('papayawhip')
fig.set_facecolor('lightsteelblue')

os.chdir('/Irgendwohin')
fig.savefig('peanuts.pdf',dpi=300,format='pdf',facecolor='lightsteelblue')
